import joblib
from flask import Flask, g
#from flask.globals import app_ctx
from flask import request
from flask import jsonify
import numpy as np
import pickle

#from flask_restful import Api
#from sqlalchemy import create_engine
#from sqlalchemy.orm import scoped_session

from unip.mlcmp.sklearn.config import MODEL_KIND, MODEL_PATH
#from unip.mlcmp.sklearn.db import DbSession
#from unip.mlcmp.sklearn.file_predict import PredictionInputFileRef, PredictionTask

app = Flask(__name__)

# todo app factory, tests

#g.db_session = scoped_session(DbSession)

# scoped_session(DbSession, scopefunc=_app_ctx_stack.__ident_func__) # old, flask 2
# scoped_session(DbSession, scopefunc=greenlet.getcurrent) # new

#@app.teardown_appcontext
#def remove_session(*args, **kwargs):
#    g.db_session.remove()

#api = Api(app)
#api.add_resource(PredictionInputFileRef, '/prediction_input_file_refs/<string:token>',
#                 endpoint='prediction_input_file_ref')
#api.add_resource(PredictionTask, '/prediction_tasks/<string:token>',
#                 endpoint='prediction_task')



def _load_model():
    if MODEL_KIND == 'pickle':
        return pickle.load(open(MODEL_PATH, 'rb'))
    if MODEL_KIND == 'joblib':
        return joblib.load(MODEL_PATH)
    raise AttributeError(f'Not supported MODEL_KIND={MODEL_KIND}')


model = _load_model()


def create_model_input_from_request(request):
    input_data = request.json
    x = np.array(input_data)
    return x


def create_response_from_model_output(output, model):
    return jsonify(output.tolist())


@app.route('/api/predict', methods=['POST'])
def predict():
    x = create_model_input_from_request(request)
    res = model.predict(x)
    return create_response_from_model_output(res, model)
