import json

from minio import Minio
from minio.credentials import EnvAWSProvider

from unip.mlcmp.sklearn.config import MODEL_FROM_S3_LOCAL_PATH, MODEL_S3_HOST_PORT, MODEL_S3_BUCKET_PATH_METADATA_FILE


def download_model():
    json_metadata = MODEL_S3_BUCKET_PATH_METADATA_FILE
    metadata = json.load(open(json_metadata))
    bucket_name = metadata['bucket_name']
    bucket_model_file_path = metadata['bucket_model_file_path']

    host = MODEL_S3_HOST_PORT

    # AWS_ACCESS_KEY_ID, AWS_SECRET_ACCESS_KEY
    client = Minio(host, credentials=EnvAWSProvider(), secure=False)

    client.fget_object(bucket_name, bucket_model_file_path, MODEL_FROM_S3_LOCAL_PATH)


if __name__ == "__main__":
    download_model()
