from flask import url_for
from flask_restful import Resource, reqparse, marshal_with, fields

# todo: пока сделать протоколы для нужных репозиториев, в них реализацию на sqlalchemy core
#  минимальное отделение сервисов от БД, потенциал для перехода в будущем к layered architecture

prediction_input_file_ref_fields = {
    'put_presigned_url': fields.String,
    'token': fields.String
}


class PredictionInputFileRef(Resource):

    def post(self):
        res = {} #token, put_presigned_url
        uri = url_for('prediction_input_file_ref', token=res.token)
        return {}, 201, {'Location': uri}

    @marshal_with(prediction_input_file_ref_fields)
    def get(self, token):
        res = {}
        return res


prediction_task_post_parser = reqparse.RequestParser()
prediction_task_post_parser.add_argument('prediction_input_file_ref_token', type=str)

prediction_task_fields = {
    'token': fields.String,
    'status': fields.String,
    'prediction_input_file_ref_token': fields.String,
    'prediction_output_file_get_presigned_url': fields.String
}


class PredictionTask(Resource):

    def post(self):
        args = prediction_task_post_parser.parse_args()
        task = {}
        uri = url_for('prediction_task', id=task.token)
        return {}, 201, {'Location': uri}

    @marshal_with(prediction_task_fields)
    def get(self, token):
        task = {}
        return task

